// -------------------------------------------------------------------------------
// 
// 		cwCu		TEhf[^ϊvOwb_t@C
// 
// 				Ver 3.24e
// 
// -------------------------------------------------------------------------------

#ifndef DX_SOUNDCONVERT_H
#define DX_SOUNDCONVERT_H

#include "DxCompileConfig.h"

#ifndef DX_NON_SOUND

// CN[h ------------------------------------------------------------------

#include "DxLib.h"

#ifdef WINDOWS_DESKTOP_OS
	#include "Windows/DxSoundConvertWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
	#include "Android/DxSoundConvertAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxSoundConvertiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// ^Cv
#define SOUND_METHODTYPE_NORMAL				(0)		// ʏ̏(ʂȏ͋܂Ȃ)
#define SOUND_METHODTYPE_OGG				(1)		// nffgp
#define SOUND_METHODTYPE_OPUS				(2)		// Opusgp
#define SOUND_METHODTYPE_DEFAULT_NUM		(3)		// ɈˑȂ^Cv̐

// `NhcZbg}N
#define RIFFCHUNKID( C1 , C2 , C3 , C4 )	( DWORD )( ((( DWORD )C4)<<24) | ((( DWORD )C3)<<16) | ((( DWORD )C2)<<8) | (C1) ) 

#ifndef WAVE_FORMAT_IEEE_FLOAT
#define WAVE_FORMAT_IEEE_FLOAT		0x0003
#endif

#ifndef WAVE_FORMAT_PCM
#define WAVE_FORMAT_PCM				0x0001
#endif

// \̒` --------------------------------------------------------------------

// RIFF`Nf[^
struct ___RIFFCHUNK
{
	DWORD						fcc ;
	DWORD						 cb ;
} ;

// v`udf[^ϊp\
struct SOUNDCONV_WAVE
{
	BYTE						*SrcBuffer ;		// ϊ̃f[^
	ULONGLONG					SrcBufferSize ;		// ϊobt@̃f[^TCY
	ULONGLONG					SrcSampleNum ;		// ϊobt@̃Tv
	LONGLONG					LoopStart, LoopEnd ;	// [v
	WAVEFORMATEX				SrcFormat ;			// ϊobt@̃tH[}bg
} ;

// f[^ϊp\
struct SOUNDCONV
{
	int							InitializeFlag ;		// ĂꍇɗtO
	int							EndFlag ;				// ϊI痧tO
	
	int 						MethodType ;			// ^Cv( SOUND_METHODTYPE_NORMAL  )
	STREAMDATA 					Stream ;				// f[^ǂݍݗpXg[f[^

	LONGLONG					HeaderPos ;				// wb_̂ʒu
	LONGLONG					HeaderSize ;			// wb_̃TCY
	LONGLONG					DataPos ;				// f[^̂ʒu
	LONGLONG					DataSize ;				// f[^̃TCY

	WAVEFORMATEX				OutFormat ;				// ϊ̃tH[}bg

	char						ConvFunctionBuffer[ 1024 ] ;	// MethodType ʃf[^ۑpobt@̈

	void						*DestData ;				// ϊ̃f[^ꎞIɕۑ郁̈
	LONGLONG					DestDataSize ;			// ϊ̃f[^ꎞIɕۑ郁̈̃TCY
	LONGLONG					DestDataValidSize ;		// ϊ̃f[^̗LȃTCY
	LONGLONG					DestDataCompSize ;		// ϊ̃f[^ꎞIɕۑ郁̈撆̓]ς݂̃TCY
	LONGLONG					DestDataCompSizeAll ;	// ϊJn猻݂Ɏ܂łɓ]f[^̃TCY

	LONGLONG					SeekLockPosition ;		// \V[Nʒu(`bl^CvŃ[vꍇׂ̈̃f[^)
#ifndef DX_NON_OGGVORBIS
	int							OggVorbisBitDepth ;			// nugp̃rbg[x(1:8bit 2:16bit)
	int							OggVorbisFromTheoraFile ;	// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif
} ;

// TEhϊŜŎgpf[^\
struct SOUNDCONVERTDATA
{
	int							InitializeFlag ;				// tO
} ;

// ϐ錾 --------------------------------------------------------------

extern SOUNDCONVERTDATA GSoundConvertData ;

// ֐vg^Cv錾-----------------------------------------------------------

// EI֐
extern	int InitializeSoundConvert( void ) ;														// TEhf[^ϊ̏s
extern	int TerminateSoundConvert( void ) ;															// TEhf[^ϊ̏Is

// tH[}bgϊp
extern	int      SetupSoundConvert( SOUNDCONV *SoundConv, STREAMDATA *Stream, int DisableReadSoundFunctionMask = 0, int OggVorbisBitDepth = 2, int OggVorbisFromTheoraFile = FALSE ) ;	// ϊ̃ZbgAbv( [] -1:G[ )
//extern int     SetTimeSoundConvert(          SOUNDCONV *SoundConv, int Time ) ;							// ϊ̈ʒuύX( ~bP )
extern	int      SetSampleTimeSoundConvert(    SOUNDCONV *SoundConv, LONGLONG SampleTime ) ;				// ϊ̈ʒuύX( TvP )
extern	int      SetupSeekPosSoundConvert(     SOUNDCONV *SoundConv, LONGLONG SeekPos ) ;					// V[N\̈ʒuZbgĂ(`blׂ̈)
extern	size_t   RunSoundConvert(              SOUNDCONV *SoundConv, void *DestBuffer, size_t DestSize ) ;	// w̃TCY( [] -1:G[  0ȏ:ϊTCY )
extern	int      TerminateSoundConvert(        SOUNDCONV *SoundConv ) ;										// ϊ̌ns
extern	int      GetOutSoundFormatInfo(        SOUNDCONV *SoundConv, WAVEFORMATEX *OutWaveFormat ) ;		// ϊ̉`擾( [] -1:G[  0ȏ:ϊ̃TCY )
extern	int      GetSoundConvertLoopAreaInfo(  SOUNDCONV *SoundConv, LONGLONG *LoopStartPos, LONGLONG *LoopEndPos ) ;	// [v擾( [] -1:G[ )
extern	int      GetSoundConvertEndState(      SOUNDCONV *SoundConv ) ;										// ϊIĂ邩ǂ擾( [] TRUE:I  FALSE:܂IĂȂ )
extern	LONGLONG GetSoundConvertDestSize_Fast( SOUNDCONV *SoundConv ) ;										// ϊ̑}̃f[^TCY𓾂
extern	int      SoundConvertFast(             SOUNDCONV *SoundConv, WAVEFORMATEX *FormatP, void **DestBufferP, size_t *DestSizeP ) ;	// Ȉꊇϊ


// ˑEI֐
extern	int      InitializeSoundConvert_PF( void ) ;														// TEhf[^ϊ̊ˑ̏s
extern	int      TerminateSoundConvert_PF( void ) ;															// TEhf[^ϊ̊ˑ̏Is

extern	int      SetupSoundConvert_PF( SOUNDCONV *SoundConv, STREAMDATA *Stream, int DisableReadSoundFunctionMask ) ;	// (ˑ)ϊ̃ZbgAbv( [] -1:G[ )
extern	int      SetSampleTimeSoundConvert_PF(    SOUNDCONV *SoundConv, LONGLONG SampleTime ) ;				// (ˑ)ϊ̈ʒuύX( TvP )
extern	int      ConvertProcessSoundConvert_PF(   SOUNDCONV *SoundConv ) ;									// (ˑ)ϊ̃obt@Ƀf[^[
extern	int      TerminateSoundConvert_PF(        SOUNDCONV *SoundConv ) ;									// (ˑ)ϊ̌ns
extern	LONGLONG GetSoundConvertDestSize_Fast_PF( SOUNDCONV *SoundConv ) ;									// (ˑ)ϊ̑}̃f[^TCY𓾂

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_SOUND

#endif // DX_SOUNDCONVERT_H
